class Changer expands Mutator config(MHReplacer);

var config float bRepDelay;

event PreBeginPlay()
{
	SetTimer(bRepDelay,False);
}

function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
	local MChanger M;

	if ( ScriptedPawn(Other) != None && ScriptedPawn(Other).Health > 0 && Level.bStartup)
	{
		M = spawn(class'MChanger',Other,,Other.Location,Other.Rotation);
		return True;
	}

	bSuperRelevant = 0;
	return true;
}

event Timer()
{
	DoChangeMonster();
}

function DoChangeMonster()
{
	local ThingFactory T;
//	local ScriptedPawn S;
//	local MChanger M;
	local string Proto;
	local bool bFoundMatch;

	log ("Level is"@Level.GetURLMap());
	foreach AllActors (class 'ThingFactory',T)
	{
		if ( T != None )
		{
			bFoundMatch = False;
			proto = Caps(T.Prototype);
			log (T@"claims prototype"@proto);
			if ( Left((Caps(Level.GetURLMap())),Len(Level.GetURLMap())-4 ) == Left((proto),Len(Level.GetURLMap())-4) )
			{
				log (T@"with Prototype"@proto@"has been excepted.");
				bFoundMatch = True; //Presuming we have a deal to skip next checks
			}
			if ( proto != "" )
			{
				if ( (Right((proto),8)=="BEHEMOTH") && !bFoundMatch)
				{
					T.Prototype = class'NsMonster.NsBehemoth';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),11)=="LESSERBRUTE") && !bFoundMatch)
				{
					T.Prototype = class'NsMonster.NsLesserBrute';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),5)=="BRUTE") && !bFoundMatch)
				{
					T.Prototype = class'NsMonster.NsBrute';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),9)=="DEVILFISH") && !bFoundMatch)
				{
					T.Prototype = class'NsMonster.NsDevilFish';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),3)=="FLY") && !bFoundMatch)
				{
					T.Prototype = class'NsMonster.NsFly';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),11)=="GIANTGASBAG") && !bFoundMatch)
				{
					T.Prototype = class'NsMonster.NsGiantGasbag';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),6)=="GASBAG") && !bFoundMatch)
				{
					T.Prototype = class'NsMonster.NsGasbag';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),12)=="LEGLESSKRALL") && !bFoundMatch)
				{
					T.Prototype = class'NsMonster.NsLeglessKrall';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),10)=="KRALLELITE") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsKrallElite';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),5)=="KRALL") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsKrall';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),10)=="GIANTMANTA") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsGiantManta';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),9)=="CAVEMANTA") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsCaveManta';
					bFoundMatch = True;
				}
				else if ( (Right((proto),5)=="MANTA") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsManta';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),14)=="MERCENARYELITE") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsMercenaryElite';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),9)=="MERCENARY") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsMercenary';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),5)=="PUPAE") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsPupae';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),5)=="QUEEN") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsQueen';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),12)=="SKAARJSNIPER") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsSkaarjSniper';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),13)=="SKAARJOFFICER") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsSkaarjOfficer';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),14)=="SKAARJINFANTRY") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsSkaarjInfantry';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),12)=="SKAARJGUNNER") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsSkaarjGunner';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),13)=="SKAARJTROOPER") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsSkaarjTrooper';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),11)=="SKAARJSCOUT") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsSkaarjScout';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),10)=="SKAARJLORD") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsSkaarjLord';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),15)=="SKAARJBERSERKER") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsSkaarjBerserker';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),14)=="SKAARJASSASSIN") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsSkaarjAssassin';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),9)=="ICESKAARJ") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsIceSkaarj';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),13)=="SKAARJWARRIOR") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsSkaarjWarrior';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),5)=="SLITH") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsSlith';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),5)=="SQUID") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsSquid';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),8)=="TENTACLE") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsTentacle';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),10)=="STONETITAN") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsStoneTitan';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),5)=="TITAN") && !bFoundMatch)
				{
					T.Prototype = class'NsMonster.NsTitan';
					bFoundMatch = True;
					log (T@"changed.");
				}
				else if ( (Right((proto),7)=="WARLORD") && !bFoundMatch )
				{
					T.Prototype = class'NsMonster.NsWarlord';
					bFoundMatch = True;
					log (T@"changed.");
				}
			}
		}
	}
/*
	foreach AllActors (class'ScriptedPawn',S)
	{
		if ( S != None && S.Health > 0)
		{
			M = spawn(class'MChanger',S,,S.Location,S.Rotation);
		}
	}
*/
}

defaultproperties
{
   bRepDelay=0.500000
}