class MChanger expands Actor config(MHReplacer);

var config float bRepDelay;
var ScriptedPawn OldM, RealM;
var class<ScriptedPawn> NewM;
var class<actor> RP;
var bool bFirstCopy, bSecondCopy, bSuccess;
var bool bIsHidden;
var vector OldMRotation, OldMLocation;
var rotator OldMRotationRate;
var Weapon W, W1;
var int Health, OldHealth;
var float OldScale;
var byte OldFat;
var name MState;
var string Cls, ReducedDamagePct, ReducedDamageType,
MultiSkins0, MultiSkins1, MultiSkins2, MultiSkins3,
MultiSkins4, MultiSkins5, MultiSkins6, MultiSkins7,
AnimSequenc, AnimFram, AnimRat,
TeamTag, bTeamLeader, AlarmTag, Orders, OrderTag, OrderObject, SharedAlarmTag, 
Aggressiveness, FirstHatePlayerEvent, bIgnoreFriends, bDelayedPatrol,
bLeadTarget, bWarnTarget, bIsBoss, bIsWuss, bNoWait, bHateWhenTriggered, bQuiet, bCanStrafe,
bInitialFear, bSpecialGoal, Home, bFixedStart, Enemy, AttitudeToPlayer, InitialState,
SpecialGoal, SpecialPause, RangedProjectile, DropWhenKilled, 
RefireRate, Skill, MenuName, NameArticle, bHasRangedAttack, bMovingRangedAttack,
CombatStyle, MeleeRange, ProjectileSpeed, TimeBetweenAttacks, AccelRate, AirControl,
AirSpeed, AttachTag, bBounce, bRotateToDesired, Buoyancy, GroundSpeed, JumpZ,
Mass, UnderWaterTime, WaterSpeed, HearingThreshold, Intelligence, PeripheralVision, SightRadius,
bButtonPusher, bFakeDeath, ClawDamage, LungeDamage, SpinDamage, PoundDamage, PunchDamage,
bHasInvulnerableShield, bSquatter, bTalker, OrdersGiven, bNeverBow, WeaponType,
bTurret, WhipDamage, BiteDamage, RipDamage, bDicePlayer, bSleeping, bSpearToss,
MinDuckTime, StrikeDamage, ThrowDamage, StingDamage, bCanFireWhileInvulnerable,
invulnerableCharge, ScreamEvent, StabDamage, SlapDamage, ThrustDamage,
StepEvent, StompEvent, bTeleportWhenHurt;
var Texture Sk, ms0, ms1, ms2, ms3, ms4, ms5, ms6, ms7, tux;
event PostBeginPlay()
{
	bGameRelevant=False;
	if ( ScriptedPawn(Owner) != None )
	{
		OldM = ScriptedPawn(Owner);
//		Health = OldM.Health;
	}
	SetTimer(bRepDelay,False);
}

function AquireMainData()
{
	local string tmCr, tmCr1;
	local bool bNotGood;

	if (OldM != None)
	{
		bFirstCopy = True;
		Cls = Caps(OldM.Class);
		if ( Cls != "")
		{
			bNotGood = True; //Assuming no good creature
			tmCr = Left((Cls),8);
			if ( tmCr == "UNREALI." )
				bNotGood = False;
			tmCr1 = Left((Cls),12);
			if  ( tmCr1 == "UNREALSHARE." )
				bNotGood = False;
			if ( bNotGood )
			{
				log (Cls@"doesn't seems a Stock creature... Quiting!");
				Destroy();
				return;
			}
			/* Health = OldM.Health;*/ Mesh = OldM.default.Mesh; Sk = OldM.Skin;
			MState=OldM.GetStateName();
			if (OldM.IsInState('GameEnded'))
				OldM.GotoState('Auto','Begin');
			tux = OldM.Texture;
			ms0 = OldM.MultiSkins[0]; ms1 = OldM.MultiSkins[1];
			ms2 = OldM.MultiSkins[2]; ms3 = OldM.MultiSkins[3];
			ms4 = OldM.MultiSkins[4]; ms5 = OldM.MultiSkins[5];
			ms6 = OldM.MultiSkins[6]; ms7 = OldM.MultiSkins[7];
//			Style = OldM.Style;
/*			log ("Tag is "$OldM.Tag);
			log ("Event is "$OldM.Event);
			log ("Orders is "$OldM.Orders);
*/
			DrawScale = OldM.DrawScale;
			bIsHidden = OldM.bHidden;
			bMeshEnviroMap = OldM.bMeshEnviroMap; bUnlit = OldM.bUnlit; bNoSmooth = OldM.bNoSmooth;
			bRandomFrame = OldM.bRandomFrame; Fatness=OldM.Fatness;
			ReducedDamagePct = OldM.GetPropertyText("ReducedDamagePct");
			MeleeRange = OldM.GetPropertyText("MeleeRange"); ProjectileSpeed = OldM.GetPropertyText("ProjectileSpeed");
			TimeBetweenAttacks = OldM.GetPropertyText("TimeBetweenAttacks"); AccelRate = OldM.GetPropertyText("AccelRate");
			AirControl = OldM.GetPropertyText("AirControl"); AirSpeed = OldM.GetPropertyText("AirSpeed"); AttachTag = OldM.GetPropertyText("AttachTag");
			bBounce = OldM.GetPropertyText("bBounce"); bRotateToDesired = OldM.GetPropertyText("bRotateToDesired"); Buoyancy = OldM.GetPropertyText("Buoyancy");
			GroundSpeed = OldM.GetPropertyText("GroundSpeed"); JumpZ = OldM.GetPropertyText("JumpZ"); Mass = OldM.GetPropertyText("Mass");
			UnderWaterTime = OldM.GetPropertyText("GroundSpeed"); WaterSpeed = OldM.GetPropertyText("WaterSpeed"); HearingThreshold = OldM.GetPropertyText("HearingThreshold");
			Intelligence = OldM.GetPropertyText("Intelligence"); PeripheralVision = OldM.GetPropertyText("PeripheralVision");
			SightRadius = OldM.GetPropertyText("SightRadius"); bCanStrafe = OldM.GetPropertyText("bCanStrafe");
			CombatStyle = OldM.GetPropertyText("CombatStyle");
			ReducedDamageType = OldM.GetPropertyText("ReducedDamageType"); AlarmTag = OldM.GetPropertyText("AlarmTag");
			SharedAlarmTag = OldM.GetPropertyText("SharedAlarmTag");
			AnimSequenc = OldM.GetPropertyText("AnimSequence");
//			AnimFram = OldM.GetPropertyText("AnimFrame");
//			AnimRat = OldM.GetPropertyText("AnimRate"); 
			TeamTag = OldM.GetPropertyText("TeamTag"); bTeamLeader = OldM.GetPropertyText("bTeamLeader");
			Orders = OldM.GetPropertyText("Orders"); OrderTag = OldM.GetPropertyText("OrderTag"); OrderObject = OldM.GetPropertyText("OrderObject");
			Aggressiveness = OldM.GetPropertyText("Aggressiveness"); FirstHatePlayerEvent = OldM.GetPropertyText("FirstHatePlayerEvent");
			bIgnoreFriends = OldM.GetPropertyText("bIgnoreFriends"); bDelayedPatrol = OldM.GetPropertyText("bDelayedPatrol");
			bQuiet = OldM.GetPropertyText("bQuiet");
			bLeadTarget = OldM.GetPropertyText("bLeadTarget"); bWarnTarget = OldM.GetPropertyText("bWarnTarget"); bIsBoss = OldM.GetPropertyText("bIsBoss");
			bIsWuss = OldM.GetPropertyText("bIsWuss"); bNoWait = OldM.GetPropertyText("bNoWait"); bHateWhenTriggered = OldM.GetPropertyText("bHateWhenTriggered");
			bInitialFear = OldM.GetPropertyText("bInitialFear"); bSpecialGoal = OldM.GetPropertyText("bSpecialGoal"); Home = OldM.GetPropertyText("Home");
			bFixedStart = OldM.GetPropertyText("bFixedStart"); Enemy = OldM.GetPropertyText("Enemy"); AttitudeToPlayer = OldM.GetPropertyText("AttitudeToPlayer");
			InitialState = OldM.GetPropertyText("InitialState"); SpecialGoal = OldM.GetPropertyText("SpecialGoal");
			SpecialPause = OldM.GetPropertyText("SpecialPause");
//			RangedProjectile = OldM.GetPropertyText("RangedProjectile");
			if ( OldM != None && OldM.RangedProjectile != None )
				RP = OldM.RangedProjectile;
			DropWhenKilled = OldM.GetPropertyText("DropWhenKilled"); RefireRate = OldM.GetPropertyText("RefireRate");
			Skill = OldM.GetPropertyText("Skill"); 
			MenuName = OldM.GetPropertyText("MenuName");
			if ( MenuName == "" )
				MenuName = OldM.GetItemName(string(OldM.Class));
			NameArticle = OldM.GetPropertyText("NameArticle");
			bHasRangedAttack = OldM.GetPropertyText("bHasRangedAttack");
			Event = OldM.Event;
			Tag = OldM.Tag;
			Self.SetRotation(OldM.Rotation);
			OldMRotationRate = OldM.RotationRate;
			if ( Right((Cls),8)=="BEHEMOTH")
			{
				bTurret = OldM.GetPropertyText("bTurret"); WhipDamage = OldM.GetPropertyText("WhipDamage");
				return;
			}
			else if ( Right((Cls),11)=="LESSERBRUTE")
			{
				bTurret = OldM.GetPropertyText("bTurret"); WhipDamage = OldM.GetPropertyText("WhipDamage");
				return;
			}
			else if ( Right((Cls),5)=="BRUTE")
			{
				bTurret = OldM.GetPropertyText("bTurret"); WhipDamage = OldM.GetPropertyText("WhipDamage");
				return;
			}
			else if ( Right((Cls),9)=="DEVILFISH")
			{
				BiteDamage = OldM.GetPropertyText("BiteDamage"); RipDamage = OldM.GetPropertyText("RipDamage");
				return;
			}
			else if ( Right((Cls),3)=="FLY")
			{
				//No particular data
				return;
			}
			else if ( Right((Cls),11)=="GIANTGASBAG")
			{
				PoundDamage = OldM.GetPropertyText("PoundDamage"); PunchDamage = OldM.GetPropertyText("PunchDamage");
				return;
			}
			else if ( Right((Cls),6)=="GASBAG")
			{
				PoundDamage = OldM.GetPropertyText("PoundDamage"); PunchDamage = OldM.GetPropertyText("PunchDamage");
				return;
			}
			else if ( Right((Cls),12)=="LEGLESSKRALL")
			{
				bDicePlayer = OldM.GetPropertyText("bDicePlayer"); bSleeping = OldM.GetPropertyText("bSleeping");
				bSpearToss = OldM.GetPropertyText("bSpearToss"); MinDuckTime = OldM.GetPropertyText("MinDuckTime");
				PoundDamage = OldM.GetPropertyText("PoundDamage"); StrikeDamage = OldM.GetPropertyText("StrikeDamage");
				ThrowDamage = OldM.GetPropertyText("ThrowDamage");
				return;
			}
			else if ( Right((Cls),10)=="KRALLELITE")
			{
				bDicePlayer = OldM.GetPropertyText("bDicePlayer"); bSleeping = OldM.GetPropertyText("bSleeping");
				bSpearToss = OldM.GetPropertyText("bSpearToss"); MinDuckTime = OldM.GetPropertyText("MinDuckTime");
				PoundDamage = OldM.GetPropertyText("PoundDamage"); StrikeDamage = OldM.GetPropertyText("StrikeDamage");
				ThrowDamage = OldM.GetPropertyText("ThrowDamage");
				return;
			}
			else if ( Right((Cls),5)=="KRALL")
			{
				bDicePlayer = OldM.GetPropertyText("bDicePlayer"); bSleeping = OldM.GetPropertyText("bSleeping");
				bSpearToss = OldM.GetPropertyText("bSpearToss"); MinDuckTime = OldM.GetPropertyText("MinDuckTime");
				PoundDamage = OldM.GetPropertyText("PoundDamage"); StrikeDamage = OldM.GetPropertyText("StrikeDamage");
				ThrowDamage = OldM.GetPropertyText("ThrowDamage");
				return;
			}
			else if ( Right((Cls),10)=="GIANTMANTA")
			{
				StingDamage = OldM.GetPropertyText("StingDamage"); WhipDamage = OldM.GetPropertyText("WhipDamage");
				return;
			}
			else if ( Right((Cls),9)=="CAVEMANTA")
			{
				StingDamage = OldM.GetPropertyText("StingDamage"); WhipDamage = OldM.GetPropertyText("WhipDamage");
				return;
			}
			else if ( Right((Cls),5)=="MANTA")
			{
				StingDamage = OldM.GetPropertyText("StingDamage"); WhipDamage = OldM.GetPropertyText("WhipDamage");
				return;
			}
			else if ( Right((Cls),14)=="MERCENARYELITE")
			{
				bButtonPusher = OldM.GetPropertyText("bButtonPusher"); bCanFireWhileInvulnerable = OldM.GetPropertyText("bCanFireWhileInvulnerable");
				bHasInvulnerableShield = OldM.GetPropertyText("bHasInvulnerableShield"); bSquatter = OldM.GetPropertyText("bSquatter");
				bTalker = OldM.GetPropertyText("bTalker"); invulnerableCharge = OldM.GetPropertyText("invulnerableCharge");
				OrdersGiven = OldM.GetPropertyText("OrdersGiven"); PunchDamage = OldM.GetPropertyText("PunchDamage");
				return;
			}
			else if ( Right((Cls),9)=="MERCENARY")
			{
				bButtonPusher = OldM.GetPropertyText("bButtonPusher"); bCanFireWhileInvulnerable = OldM.GetPropertyText("bCanFireWhileInvulnerable");
				bHasInvulnerableShield = OldM.GetPropertyText("bHasInvulnerableShield"); bSquatter = OldM.GetPropertyText("bSquatter");
				bTalker = OldM.GetPropertyText("bTalker"); invulnerableCharge = OldM.GetPropertyText("invulnerableCharge");
				OrdersGiven = OldM.GetPropertyText("OrdersGiven"); PunchDamage = OldM.GetPropertyText("PunchDamage");
				return;
			}
			else if ( Right((Cls),5)=="PUPAE")
			{
				BiteDamage = OldM.GetPropertyText("BiteDamage"); LungeDamage = OldM.GetPropertyText("LungeDamage");
				return;
			}
			else if ( Right((Cls),5)=="QUEEN")
			{
				ClawDamage = OldM.GetPropertyText("ClawDamage"); ScreamEvent = OldM.GetPropertyText("ScreamEvent");
				StabDamage = OldM.GetPropertyText("StabDamage");
				return;
			}
			else if ( Right((Cls),12)=="SKAARJSNIPER")
			{
				bButtonPusher = OldM.GetPropertyText("bButtonPusher"); bFakeDeath = OldM.GetPropertyText("bFakeDeath");
				ClawDamage = OldM.GetPropertyText("ClawDamage"); SpinDamage = OldM.GetPropertyText("SpinDamage");
				LungeDamage = OldM.GetPropertyText("LungeDamage");
				WeaponType = OldM.GetPropertyText("WeaponType");
//				log (WeaponType@" is Weapon captured");
				return;
			}
			else if ( Right((Cls),13)=="SKAARJOFFICER")
			{
				bButtonPusher = OldM.GetPropertyText("bButtonPusher"); bFakeDeath = OldM.GetPropertyText("bFakeDeath");
				ClawDamage = OldM.GetPropertyText("ClawDamage"); SpinDamage = OldM.GetPropertyText("SpinDamage");
				LungeDamage = OldM.GetPropertyText("LungeDamage");
				WeaponType = OldM.GetPropertyText("WeaponType");
				return;
			}
			else if ( Right((Cls),14)=="SKAARJINFANTRY")
			{
				bButtonPusher = OldM.GetPropertyText("bButtonPusher"); bFakeDeath = OldM.GetPropertyText("bFakeDeath");
				ClawDamage = OldM.GetPropertyText("ClawDamage"); SpinDamage = OldM.GetPropertyText("SpinDamage");
				LungeDamage = OldM.GetPropertyText("LungeDamage");
				WeaponType = OldM.GetPropertyText("WeaponType");
				return;
			}
			else if ( Right((Cls),12)=="SKAARJGUNNER")
			{
				bButtonPusher = OldM.GetPropertyText("bButtonPusher"); bFakeDeath = OldM.GetPropertyText("bFakeDeath");
				ClawDamage = OldM.GetPropertyText("ClawDamage"); SpinDamage = OldM.GetPropertyText("SpinDamage");
				LungeDamage = OldM.GetPropertyText("LungeDamage");
				WeaponType = OldM.GetPropertyText("WeaponType");
				return;
			}
			else if ( Right((Cls),13)=="SKAARJTROOPER")
			{
				bButtonPusher = OldM.GetPropertyText("bButtonPusher"); bFakeDeath = OldM.GetPropertyText("bFakeDeath");
				ClawDamage = OldM.GetPropertyText("ClawDamage"); SpinDamage = OldM.GetPropertyText("SpinDamage");
				LungeDamage = OldM.GetPropertyText("LungeDamage");
				WeaponType = OldM.GetPropertyText("WeaponType");
				return;
			}
			else if ( Right((Cls),11)=="SKAARJSCOUT")
			{
				bButtonPusher = OldM.GetPropertyText("bButtonPusher"); bFakeDeath = OldM.GetPropertyText("bFakeDeath");
				ClawDamage = OldM.GetPropertyText("ClawDamage"); SpinDamage = OldM.GetPropertyText("SpinDamage");
				LungeDamage = OldM.GetPropertyText("LungeDamage");
				return;
			}
			else if ( Right((Cls),10)=="SKAARJLORD")
			{
				bButtonPusher = OldM.GetPropertyText("bButtonPusher"); bFakeDeath = OldM.GetPropertyText("bFakeDeath");
				ClawDamage = OldM.GetPropertyText("ClawDamage"); SpinDamage = OldM.GetPropertyText("SpinDamage");
				LungeDamage = OldM.GetPropertyText("LungeDamage");
				return;
			}
			else if ( Right((Cls),15)=="SKAARJBERSERKER")
			{
				bButtonPusher = OldM.GetPropertyText("bButtonPusher"); bFakeDeath = OldM.GetPropertyText("bFakeDeath");
				ClawDamage = OldM.GetPropertyText("ClawDamage"); SpinDamage = OldM.GetPropertyText("SpinDamage");
				LungeDamage = OldM.GetPropertyText("LungeDamage");
				return;
			}
			else if ( Right((Cls),14)=="SKAARJASSASSIN")
			{
				bButtonPusher = OldM.GetPropertyText("bButtonPusher"); bFakeDeath = OldM.GetPropertyText("bFakeDeath");
				ClawDamage = OldM.GetPropertyText("ClawDamage"); SpinDamage = OldM.GetPropertyText("SpinDamage");
				LungeDamage = OldM.GetPropertyText("LungeDamage");
				return;
			}
			else if ( Right((Cls),9)=="ICESKAARJ")
			{
				bButtonPusher = OldM.GetPropertyText("bButtonPusher"); bFakeDeath = OldM.GetPropertyText("bFakeDeath");
				ClawDamage = OldM.GetPropertyText("ClawDamage"); SpinDamage = OldM.GetPropertyText("SpinDamage");
				LungeDamage = OldM.GetPropertyText("LungeDamage");
				return;
			}
			else if ( Right((Cls),13)=="SKAARJWARRIOR")
			{
				bButtonPusher = OldM.GetPropertyText("bButtonPusher"); bFakeDeath = OldM.GetPropertyText("bFakeDeath");
				ClawDamage = OldM.GetPropertyText("ClawDamage"); SpinDamage = OldM.GetPropertyText("SpinDamage");
				LungeDamage = OldM.GetPropertyText("LungeDamage");
				return;
			}
			else if ( Right((Cls),5)=="SLITH")
			{
				ClawDamage = OldM.GetPropertyText("ClawDamage");
				return;
			}
			else if ( Right((Cls),5)=="SQUID")
			{
				SlapDamage = OldM.GetPropertyText("SlapDamage"); ThrustDamage = OldM.GetPropertyText("ThrustDamage");
				return;
			}
			else if ( Right((Cls),8)=="TENTACLE")
			{
				WhipDamage = OldM.GetPropertyText("WhipDamage");
			}
			else if ( Right((Cls),10)=="STONETITAN")
			{
				PunchDamage = OldM.GetPropertyText("PunchDamage"); SlapDamage = OldM.GetPropertyText("SlapDamage");
				StepEvent = OldM.GetPropertyText("StepEvent"); StompEvent = OldM.GetPropertyText("StompEvent");
				return;
			}
			else if ( Right((Cls),5)=="TITAN")
			{
				PunchDamage = OldM.GetPropertyText("PunchDamage"); SlapDamage = OldM.GetPropertyText("SlapDamage");
				StepEvent = OldM.GetPropertyText("StepEvent"); StompEvent = OldM.GetPropertyText("StompEvent");
				return;
			}
			else if ( Right((Cls),7)=="WARLORD")
			{
				bTeleportWhenHurt = OldM.GetPropertyText("bTeleportWhenHurt"); StrikeDamage = OldM.GetPropertyText("StrikeDamage");
			}
			else
				{
					Log (Self@"has spawned for"@OldM$". Replacement unavailable.");
					Destroy();
				}
		}
	}
	else Log("Monster not assigned !!! ");
}

function AquireWeaponData()
{
	local Weapon W2;
	if ( OldM != None )
	{
		Health = OldM.Health;
		if ( OldM.Weapon != None )
			W = OldM.Weapon;

		if (W != None && Cls != "")
		{
			W1 = Spawn(W.Class,,,Location,Rotation);
			if ( W1 != None )
			{
				W1.RespawnTime=0;
				W.Destroy();
				Foreach W1.RadiusActors(class'Weapon',W2,W1.CollisionRadius*2)
				{
					if ( W2 != None && W2.MyMarker == None && W2 != W1 )
						W2.Destroy();
				}
			}
		}
	}
	bSecondCopy = True;
}

function TransferAllData()
{
	if ( Cls != "" )
	{
//--- Private class stuff
		if ( Right((Cls),8)=="BEHEMOTH" && NewM == None)
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsBehemoth", class'Class' ) );
		}
		else if ( Right((Cls),11)=="LESSERBRUTE" && NewM == None)
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsLesserBrute", class'Class' ) );
		}
		else if ( Right((Cls),5)=="BRUTE" && NewM == None)
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsBrute", class'Class' ) );
		}
		else if ( Right((Cls),9)=="DEVILFISH" && NewM == None)
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsDevilFish", class'Class' ) );
		}
		else if ( Right((Cls),3)=="FLY" && NewM == None)
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsFly", class'Class' ) );
		}
		else if ( Right((Cls),11)=="GIANTGASBAG" && NewM == None)
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsGiantGasbag", class'Class' ) );
		}
		else if ( Right((Cls),6)=="GASBAG" && NewM == None)
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsGasbag", class'Class' ) );
		}
		else if ( Right((Cls),12)=="LEGLESSKRALL" && NewM == None)
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsLeglessKrall", class'Class' ) );
		}
		else if ( Right((Cls),10)=="KRALLELITE" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsKrallElite", class'Class' ) );
		}
		else if ( Right((Cls),5)=="KRALL" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsKrall", class'Class' ) );
		}
		else if ( Right((Cls),10)=="GIANTMANTA" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsGiantManta", class'Class' ) );
		}
		else if ( Right((Cls),9)=="CAVEMANTA" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsCaveManta", class'Class' ) );
		}
		else if ( Right((Cls),5)=="MANTA" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsManta", class'Class' ) );
		}
		else if ( Right((Cls),14)=="MERCENARYELITE" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsMercenaryElite", class'Class' ) );
		}
		else if ( Right((Cls),9)=="MERCENARY" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsMercenary", class'Class' ) );
		}
		else if ( Right((Cls),5)=="PUPAE" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsPupae", class'Class' ) );
		}
		else if ( Right((Cls),5)=="QUEEN" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsQueen", class'Class' ) );
		}
		else if ( Right((Cls),12)=="SKAARJSNIPER" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsSkaarjSniper", class'Class' ) );
		}
		else if ( Right((Cls),13)=="SKAARJOFFICER" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsSkaarjOfficer", class'Class' ) );

		}
		else if ( Right((Cls),14)=="SKAARJINFANTRY" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsSkaarjInfantry", class'Class' ) );

		}
		else if ( Right((Cls),12)=="SKAARJGUNNER" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsSkaarjGunner", class'Class' ) );

		}
		else if ( Right((Cls),13)=="SKAARJTROOPER" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsSkaarjTrooper", class'Class' ) );
		}
		else if ( Right((Cls),11)=="SKAARJSCOUT" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsSkaarjScout", class'Class' ) );
		}
		else if ( Right((Cls),10)=="SKAARJLORD" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsSkaarjLord", class'Class' ) );
		}
		else if ( Right((Cls),15)=="SKAARJBERSERKER" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsSkaarjBerserker", class'Class' ) );
		}
		else if ( Right((Cls),14)=="SKAARJASSASSIN" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsSkaarjAssassin", class'Class' ) );
		}
		else if ( Right((Cls),9)=="ICESKAARJ" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsIceSkaarj", class'Class' ) );
		}
		else if ( Right((Cls),13)=="SKAARJWARRIOR" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsSkaarjWarrior", class'Class' ) );
		}
		else if ( Right((Cls),5)=="SLITH" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsSlith", class'Class' ) );
		}
		else if ( Right((Cls),5)=="SQUID" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsSquid", class'Class' ) );
		}
		else if ( Right((Cls),8)=="TENTACLE" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsTentacle", class'Class' ) );
		}
		else if ( Right((Cls),10)=="STONETITAN" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsStoneTitan", class'Class' ) );
		}
		else if ( Right((Cls),5)=="TITAN" && NewM == None)
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsTitan", class'Class' ) );
		}
		else if ( Right((Cls),7)=="WARLORD" && NewM == None )
		{
			NewM = class<ScriptedPawn>( DynamicLoadObject( "NsMonster.NsWarlord", class'Class' ) );
		}
//--- Common Data
		if ( NewM != None )
		{
/*
Skin, Texture, 
MultiSkins0, MultiSkins1, MultiSkins2, MultiSkins3,
MultiSkins4, MultiSkins5, MultiSkins6, MultiSkins7,
Fatness, Event, Tag;
ReducedDamagePct, ReducedDamageType,
DrawScale, AnimSequence, AnimFrame, AnimRate, bMeshEnviroMap,
bUnlit, TeamTag, bTeamLeader, AlarmTag, Orders, OrderTag, OrderObject, SharedAlarmTag, 
Aggressiveness, FirstHatePlayerEvent, bIgnoreFriends, bDelayedPatrol,
bLeadTarget, bWarnTarget, bIsBoss, bIsWuss, bNoWait, bHateWhenTriggered, bQuiet, bCanStrafe,
bInitialFear, bSpecialGoal, Home, bFixedStart, Enemy, AttitudeToPlayer, InitialState,
SpecialGoal, SpecialPause, RangedProjectile, DropWhenKilled, 
RefireRate, Skill, MenuName, NameArticle, bHasRangedAttack, bMovingRangedAttack,
CombatStyle, MeleeRange, ProjectileSpeed, TimeBetweenAttacks, AccelRate, AirControl,
AirSpeed, AttachTag, bBounce, bRotateToDesired, Buoyancy, GroundSpeed, JumpZ,
Mass, UnderWaterTime, WaterSpeed, HearingThreshold, Intelligence, PeripheralVision, SightRadius,
*/
				NewM.Default.Mesh = Mesh;
				OldFat = NewM.default.Fatness;
//				log (Self$" NewM speak "$OldFat);
				NewM.default.Fatness=Fatness;
				OldScale = NewM.default.DrawScale;
//				log (Self$" NewM speak "$OldScale);
				NewM.default.DrawScale=DrawScale;
			NewM.default.bCollideWhenPlacing = False;
			NewM.default.bCollideWorld = False;
			if ( W != None ) //Destroy old weapon with owner missing - it has been removed a few time ago
				W.Destroy();
			RealM = spawn(NewM,,,Location,Rotation);
			if ( RealM != None )
			{
				RealM.GotoState(MState);
//-- Warning, must put back exactly default Pawn values after spawning new dude, else if Level has big Guys
//-- Next spawned waves from the same class are going to get screwed
				NewM.default.DrawScale=OldScale;
				NewM.default.Fatness=OldFat;
				RealM.default.bCollideWhenPlacing = True;
				RealM.bCollideWorld = True;
				RealM.default.bCollideWorld = True;
				RealM.SetCollision(False,False,False);
				if ( sk != None )
					RealM.Skin = Sk;
				if ( tux != None )
					RealM.Texture = Tux;
				if (ms0 != None)
					RealM.MultiSkins[0] = ms0;
				if (ms1 != None)
					RealM.MultiSkins[1] = ms1;
				if (ms2 != None)
					RealM.MultiSkins[2] = ms2;
				if (ms3 != None)
					RealM.MultiSkins[3] = ms3;
				if (ms4 != None)
					RealM.MultiSkins[4] = ms4;
				if (ms5 != None)
					RealM.MultiSkins[5] = ms5;
				if (ms6 != None)
					RealM.MultiSkins[6] = ms6;
				if (ms7 != None)
					RealM.MultiSkins[7] = ms7;
				RealM.bMeshEnviroMap = bMeshEnviroMap;
				RealM.bUnlit = bUnlit;
				RealM.bNoSmooth = bNoSmooth;
				RealM.Style = Style;
				RealM.Event = Event;
				RealM.Tag = Tag;
				RealM.bHidden = bIsHidden;
				RealM.SetCollisionSize(RealM.CollisionRadius*RealM.DrawScale/OldScale,RealM.CollisionHeight*RealM.DrawScale/OldScale);
				RealM.Health = Health; //Got it a delayed
				RealM.SetPropertyText("ReducedDamagePct",ReducedDamagePct);
				RealM.SetPropertyText("ReducedDamageType",ReducedDamageType);
				if (AnimSequenc != "")
					RealM.SetPropertyText("AnimSequence",AnimSequenc);
				if (AnimFram != "")
					RealM.SetPropertyText("AnimFrame",AnimFram);
				if (AnimRat != "")
					RealM.SetPropertyText("AnimRate",AnimRat);
				RealM.SetPropertyText("TeamTag",TeamTag);
				RealM.SetPropertyText("bTeamLeader",bTeamLeader); RealM.SetPropertyText("AlarmTag",AlarmTag); RealM.SetPropertyText("Orders",Orders);
				RealM.SetPropertyText("OrderTag",OrderTag); RealM.SetPropertyText("OrderObject",OrderObject); RealM.SetPropertyText("SharedAlarmTag",SharedAlarmTag);
				RealM.SetPropertyText("Aggressiveness",Aggressiveness); RealM.SetPropertyText("FirstHatePlayerEvent",FirstHatePlayerEvent); RealM.SetPropertyText("bIgnoreFriends",bIgnoreFriends);
				RealM.SetPropertyText("bDelayedPatrol",bDelayedPatrol); RealM.SetPropertyText("bLeadTarget",bLeadTarget); RealM.SetPropertyText("bWarnTarget",bWarnTarget);
				RealM.SetPropertyText("bIsBoss",bIsBoss); RealM.SetPropertyText("bIsWuss",bIsWuss); RealM.SetPropertyText("bNoWait",bNoWait);
				RealM.SetPropertyText("bHateWhenTriggered",bHateWhenTriggered); RealM.SetPropertyText("bQuiet",bQuiet); RealM.SetPropertyText("bCanStrafe",bCanStrafe);
				RealM.SetPropertyText("bInitialFear",bInitialFear); RealM.SetPropertyText("bSpecialGoal",bSpecialGoal); RealM.SetPropertyText("Home",Home);
				RealM.SetPropertyText("bFixedStart",bFixedStart); RealM.SetPropertyText("Enemy",Enemy); RealM.SetPropertyText("AttitudeToPlayer",AttitudeToPlayer);
				RealM.SetPropertyText("InitialState",InitialState); RealM.SetPropertyText("SpecialGoal",SpecialGoal); RealM.SetPropertyText("SpecialPause",SpecialPause);
/*
				if ( Right((Caps(RangedProjectile)),15) == "SLITHPROJECTILE" && NsSlith(RealM) != None )
				{
					NsSlith(RealM).default.RangedProjectile = class 'NsMonster.NsSlithProjectile';
					NsSlith(RealM).RangedProjectile = class 'NsMonster.NsSlithProjectile';
					log ("Match Slith");
				}
				else
					RealM.SetPropertyText("RangedProjectile",RangedProjectile);

				if (RP != None)
				{
					if ((RP.IsA('SlithProjectile') || RP.IsA('mhSlithProjectile')) && NsSlith(RealM) != None )
						NsSlith(RealM).RangedProjectile = class 'NsMonster.NsSlithProjectile';
					else
						{
							if ( ScriptedPawn(RealM) != None )
								ScriptedPawn(RealM).RangedProjectile = RP;
						}
				}
*/
				RealM.SetPropertyText("DropWhenKilled",DropWhenKilled); RealM.SetPropertyText("RefireRate",RefireRate);
				RealM.SetPropertyText("Skill",Skill);
				RealM.SetPropertyText("bHasRangedAttack",bHasRangedAttack); RealM.SetPropertyText("bMovingRangedAttack",bMovingRangedAttack); RealM.SetPropertyText("CombatStyle",CombatStyle);
				RealM.SetPropertyText("MeleeRange",MeleeRange); RealM.SetPropertyText("ProjectileSpeed",ProjectileSpeed); RealM.SetPropertyText("TimeBetweenAttacks",TimeBetweenAttacks);
				RealM.SetPropertyText("AccelRate",AccelRate); RealM.SetPropertyText("AirControl",AirControl); RealM.SetPropertyText("AirSpeed",AirSpeed);
				RealM.SetPropertyText("AttachTag",AttachTag); RealM.SetPropertyText("bBounce",bBounce); RealM.SetPropertyText("bRotateToDesired",bRotateToDesired);
				RealM.SetPropertyText("Buoyancy",Buoyancy); RealM.SetPropertyText("GroundSpeed",GroundSpeed); RealM.SetPropertyText("JumpZ",JumpZ);
				RealM.SetPropertyText("Mass",Mass); RealM.SetPropertyText("UnderWaterTime",UnderWaterTime); RealM.SetPropertyText("WaterSpeed",WaterSpeed);
				RealM.SetPropertyText("HearingThreshold",HearingThreshold); RealM.SetPropertyText("Intelligence",Intelligence); RealM.SetPropertyText("PeripheralVision",PeripheralVision);
				RealM.SetPropertyText("SightRadius",SightRadius);
				if (MenuName != "")
					RealM.SetPropertyText("MenuName",MenuName);
				if ( NameArticle != "" )
					RealM.SetPropertyText("NameArticle",NameArticle);
				else
				{
					RealM.NameArticle = " a ";
				}
				if (  ( Caps(Left((RealM.MenuName),1)) == "A"
				|| Caps(Left((RealM.MenuName),1)) == "E"
				|| Caps(Left((RealM.MenuName),1)) == "I"
				|| Caps(Left((RealM.MenuName),1)) == "O"
				|| Caps(Left((RealM.MenuName),1)) == "U" )
				&& Caps(Left((RealM.NameArticle),3)) == " A ")
					RealM.NameArticle = " an ";
/*
				log(RealM@"has AmbientGlow"@RealM.AmbientGlow);
				log(RealM@"has AnimFrame"@RealM.AnimFrame);
				log(RealM@"has AnimRate"@RealM.AnimRate);
				log(RealM@"has bMeshCurvy"@RealM.bMeshCurvy);
				log(RealM@"has Mesh"@RealM.Mesh);
				log(RealM@"has Style"@RealM.Style);
				log(RealM@"has DrawType"@RealM.DrawType);
				log(RealM@"has ScaleGlow"@RealM.ScaleGlow);
				log(RealM@"has Texture"@RealM.Texture);
				log(RealM@"has MenuName"@RealM.MenuName);
				log(RealM@"has NameArticle"@RealM.NameArticle);
				log(RealM@"has Health"@RealM.Health);
				log(RealM@"has Visibility"@RealM.Visibility);
*/
//---
			if ( Right((Cls),8)=="BEHEMOTH" )
			{
				RealM.SetPropertyText("bTurret",bTurret);
				RealM.SetPropertyText("WhipDamage",WhipDamage);
				goto SecondSection; //if already found do not check the rest with any matter
			}
			else if ( Right((Cls),11)=="LESSERBRUTE" )
			{
				RealM.SetPropertyText("bTurret",bTurret); RealM.SetPropertyText("WhipDamage",WhipDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),5)=="BRUTE" )
			{
				RealM.SetPropertyText("bTurret",bTurret); RealM.SetPropertyText("WhipDamage",WhipDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),9)=="DEVILFISH" )
			{
				RealM.SetPropertyText("BiteDamage",BiteDamage); RealM.SetPropertyText("RipDamage",RipDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),11)=="GIANTGASBAG" )
			{
				RealM.SetPropertyText("PoundDamage",PoundDamage); RealM.SetPropertyText("PunchDamage",PunchDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),6)=="GASBAG" )
			{
				RealM.SetPropertyText("PoundDamage",PoundDamage); RealM.SetPropertyText("PunchDamage",PunchDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),12)=="LEGLESSKRALL" )
			{
				RealM.SetPropertyText("bDicePlayer",bDicePlayer); RealM.SetPropertyText("bSleeping",bSleeping);
				RealM.SetPropertyText("bSpearToss",bSpearToss); RealM.SetPropertyText("MinDuckTime",MinDuckTime);
				RealM.SetPropertyText("PoundDamage",PoundDamage); RealM.SetPropertyText("StrikeDamage",StrikeDamage);
				RealM.SetPropertyText("ThrowDamage",ThrowDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),10)=="KRALLELITE" )
			{
				RealM.SetPropertyText("bDicePlayer",bDicePlayer); RealM.SetPropertyText("bSleeping",bSleeping);
				RealM.SetPropertyText("bSpearToss",bSpearToss); RealM.SetPropertyText("MinDuckTime",MinDuckTime);
				RealM.SetPropertyText("PoundDamage",PoundDamage); RealM.SetPropertyText("StrikeDamage",StrikeDamage);
				RealM.SetPropertyText("ThrowDamage",ThrowDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),5)=="KRALL" )
			{
				RealM.SetPropertyText("bDicePlayer",bDicePlayer); RealM.SetPropertyText("bSleeping",bSleeping);
				RealM.SetPropertyText("bSpearToss",bSpearToss); RealM.SetPropertyText("MinDuckTime",MinDuckTime);
				RealM.SetPropertyText("PoundDamage",PoundDamage); RealM.SetPropertyText("StrikeDamage",StrikeDamage);
				RealM.SetPropertyText("ThrowDamage",ThrowDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),10)=="GIANTMANTA" )
			{
				RealM.SetPropertyText("StingDamage",StingDamage); RealM.SetPropertyText("WhipDamage",WhipDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),9)=="CAVEMANTA" )
			{
				RealM.SetPropertyText("StingDamage",StingDamage); RealM.SetPropertyText("WhipDamage",WhipDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),5)=="MANTA" )
			{
				RealM.SetPropertyText("StingDamage",StingDamage); RealM.SetPropertyText("WhipDamage",WhipDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),14)=="MERCENARYELITE" )
			{
				RealM.SetPropertyText("bButtonPusher",bButtonPusher); RealM.SetPropertyText("bCanFireWhileInvulnerable",bCanFireWhileInvulnerable);
				RealM.SetPropertyText("bHasInvulnerableShield",bHasInvulnerableShield); RealM.SetPropertyText("bSquatter",bSquatter);
				RealM.SetPropertyText("bTalker",bTalker); RealM.SetPropertyText("invulnerableCharge",invulnerableCharge);
				RealM.SetPropertyText("OrdersGiven",OrdersGiven); RealM.SetPropertyText("PunchDamage",PunchDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),9)=="MERCENARY" )
			{
				RealM.SetPropertyText("bButtonPusher",bButtonPusher); RealM.SetPropertyText("bCanFireWhileInvulnerable",bCanFireWhileInvulnerable);
				RealM.SetPropertyText("bHasInvulnerableShield",bHasInvulnerableShield); RealM.SetPropertyText("bSquatter",bSquatter);
				RealM.SetPropertyText("bTalker",bTalker); RealM.SetPropertyText("invulnerableCharge",invulnerableCharge);
				RealM.SetPropertyText("OrdersGiven",OrdersGiven); RealM.SetPropertyText("PunchDamage",PunchDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),5)=="PUPAE" )
			{
				RealM.SetPropertyText("BiteDamage",BiteDamage); RealM.SetPropertyText("LungeDamage",LungeDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),5)=="QUEEN" )
			{
				RealM.SetPropertyText("ClawDamage",ClawDamage);
//				log("ScreamEvent is"@ScreamEvent);
				if ( ScreamEvent != "None" );
					RealM.SetPropertyText("ScreamEvent",ScreamEvent);
				RealM.SetPropertyText("StabDamage",StabDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),12)=="SKAARJSNIPER" )
			{
				RealM.SetPropertyText("bButtonPusher",bButtonPusher); RealM.SetPropertyText("bFakeDeath",bFakeDeath);
				RealM.SetPropertyText("ClawDamage",ClawDamage); RealM.SetPropertyText("SpinDamage",SpinDamage);
				RealM.SetPropertyText("LungeDamage",LungeDamage);
				RealM.SetPropertyText("WeaponType",WeaponType);
//				log ("Assigned weapon"@RealM.GetPropertyText("WeaponType"));
				goto SecondSection;
			}
			else if ( Right((Cls),13)=="SKAARJOFFICER" )
			{
				RealM.SetPropertyText("bButtonPusher",bButtonPusher); RealM.SetPropertyText("bFakeDeath",bFakeDeath);
				RealM.SetPropertyText("ClawDamage",ClawDamage); RealM.SetPropertyText("SpinDamage",SpinDamage);
				RealM.SetPropertyText("LungeDamage",LungeDamage);
				RealM.SetPropertyText("WeaponType",WeaponType);
				goto SecondSection;
			}
			else if ( Right((Cls),14)=="SKAARJINFANTRY" )
			{
				RealM.SetPropertyText("bButtonPusher",bButtonPusher); RealM.SetPropertyText("bFakeDeath",bFakeDeath);
				RealM.SetPropertyText("ClawDamage",ClawDamage); RealM.SetPropertyText("SpinDamage",SpinDamage);
				RealM.SetPropertyText("LungeDamage",LungeDamage);
				RealM.SetPropertyText("WeaponType",WeaponType);
				goto SecondSection;							//Else my troopers are sucking any closer weapon native, :P
			}
			else if ( Right((Cls),12)=="SKAARJGUNNER" )
			{
				RealM.SetPropertyText("bButtonPusher",bButtonPusher); RealM.SetPropertyText("bFakeDeath",bFakeDeath);
				RealM.SetPropertyText("ClawDamage",ClawDamage); RealM.SetPropertyText("SpinDamage",SpinDamage);
				RealM.SetPropertyText("LungeDamage",LungeDamage);
				RealM.SetPropertyText("WeaponType",WeaponType);
				goto SecondSection;
			}
			else if ( Right((Cls),13)=="SKAARJTROOPER" )
			{
				RealM.SetPropertyText("bButtonPusher",bButtonPusher); RealM.SetPropertyText("bFakeDeath",bFakeDeath);
				RealM.SetPropertyText("ClawDamage",ClawDamage); RealM.SetPropertyText("SpinDamage",SpinDamage);
				RealM.SetPropertyText("LungeDamage",LungeDamage);
				RealM.SetPropertyText("WeaponType",WeaponType);
				goto SecondSection;
			}
			else if ( Right((Cls),11)=="SKAARJSCOUT" )
			{
				RealM.SetPropertyText("bButtonPusher",bButtonPusher); RealM.SetPropertyText("bFakeDeath",bFakeDeath);
				RealM.SetPropertyText("ClawDamage",ClawDamage); RealM.SetPropertyText("SpinDamage",SpinDamage);
				RealM.SetPropertyText("LungeDamage",LungeDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),10)=="SKAARJLORD" )
			{
				RealM.SetPropertyText("bButtonPusher",bButtonPusher); RealM.SetPropertyText("bFakeDeath",bFakeDeath);
				RealM.SetPropertyText("ClawDamage",ClawDamage); RealM.SetPropertyText("SpinDamage",SpinDamage);
				RealM.SetPropertyText("LungeDamage",LungeDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),15)=="SKAARJBERSERKER" )
			{
				RealM.SetPropertyText("bButtonPusher",bButtonPusher); RealM.SetPropertyText("bFakeDeath",bFakeDeath);
				RealM.SetPropertyText("ClawDamage",ClawDamage); RealM.SetPropertyText("SpinDamage",SpinDamage);
				RealM.SetPropertyText("LungeDamage",LungeDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),14)=="SKAARJASSASSIN" )
			{
				RealM.SetPropertyText("bButtonPusher",bButtonPusher); RealM.SetPropertyText("bFakeDeath",bFakeDeath);
				RealM.SetPropertyText("ClawDamage",ClawDamage); RealM.SetPropertyText("SpinDamage",SpinDamage);
				RealM.SetPropertyText("LungeDamage",LungeDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),9)=="ICESKAARJ" )
			{
				RealM.SetPropertyText("bButtonPusher",bButtonPusher); RealM.SetPropertyText("bFakeDeath",bFakeDeath);
				RealM.SetPropertyText("ClawDamage",ClawDamage); RealM.SetPropertyText("SpinDamage",SpinDamage);
				RealM.SetPropertyText("LungeDamage",LungeDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),13)=="SKAARJWARRIOR" )
			{
				RealM.SetPropertyText("bButtonPusher",bButtonPusher); RealM.SetPropertyText("bFakeDeath",bFakeDeath);
				RealM.SetPropertyText("ClawDamage",ClawDamage); RealM.SetPropertyText("SpinDamage",SpinDamage);
				RealM.SetPropertyText("LungeDamage",LungeDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),5)=="SLITH" )
			{
				RealM.SetPropertyText("ClawDamage",ClawDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),5)=="SQUID" )
			{
				RealM.SetPropertyText("SlapDamage",SlapDamage); RealM.SetPropertyText("ThrustDamage",ThrustDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),8)=="TENTACLE" )
			{
				RealM.SetPropertyText("WhipDamage",WhipDamage);
				goto SecondSection;
			}
			else if ( Right((Cls),10)=="STONETITAN" )
			{
				RealM.SetPropertyText("PunchDamage",PunchDamage); RealM.SetPropertyText("SlapDamage",SlapDamage);
				if ( StepEvent != "None" );
					RealM.SetPropertyText("StepEvent",StepEvent);
				if (StompEvent != "None ");
					RealM.SetPropertyText("StompEvent",StompEvent);
				goto SecondSection;
			}
			else if ( Right((Cls),5)=="TITAN" )
			{
				RealM.SetPropertyText("PunchDamage",PunchDamage); RealM.SetPropertyText("SlapDamage",SlapDamage);
				if ( StepEvent != "None" );
					RealM.SetPropertyText("StepEvent",StepEvent);
				if (StompEvent != "None ");
					RealM.SetPropertyText("StompEvent",StompEvent);
				goto SecondSection;
			}
			else if ( Right((Cls),7)=="WARLORD" )
			{
				RealM.SetPropertyText("bTeleportWhenHurt",bTeleportWhenHurt); RealM.SetPropertyText("StrikeDamage",StrikeDamage);
				goto SecondSection;
			}
//---
SecondSection:
				if ( W1 != None )
				{
					if ( RealM.Weapon != None && RealM.Weapon.Class != W1.Class )
					{
						RealM.Weapon.Destroy();
						RealM.Weapon = None;
					}
					W1.BecomeItem();
					W1.Instigator = RealM;
					RealM.AddInventory(W1);
					W1.GiveAmmo(RealM);
					W1.WeaponSet(RealM);
				}
			}
		}
	}
	bSuccess=True;
}

function RemoveTrashPawn()
{
	if ( OldM != None )
	{
//		Log (Self@" > Spawned for"@OldM);
		SetOwner(None);
		OldM.Destroy();
	}
}

event Timer()
{
	if (!bFirstCopy)
	{
		AquireMainData();
		SetTimer(0.15,False);
		return;
	}
	if ( !bSecondCopy )
	{
		AquireWeaponData();
		RemoveTrashPawn();
		SetTimer(0.15,False);
		return;
	}
	if ( bSecondCopy && !bSuccess )
	{
		TransferAllData();
		SetTimer(0.15,False);
		return;
	}
	if ( bSuccess )
	{
		if (RealM != None)
		{
			RealM.SetCollision(True,True,True);
			if (RP != None)
			{
				if ((RP.IsA('SlithProjectile') || RP.IsA('mhSlithProjectile')) && NsSlith(RealM) != None )
					NsSlith(RealM).RangedProjectile = class 'NsMonster.NsSlithProjectile';
				else
					{
						if ( RealM != None )
							RealM.RangedProjectile = RP;
					}
				}
		}
		else
			log (Self@" > bork... Replacement did not spawned.");
		Destroy();
	}
}
defaultproperties
{
   bRepDelay=1.030000
   bGameRelevant=True
   bHidden=True
   bCollideActors=False
   bCollideWorld=False
   bCollideWhenPlacing=False
}